unit Unit1;

interface

{$i SaDemo.inc}

uses
  Windows, Messages, SysUtils,
  {$ifdef D_67}Variants,{$endif}
  Classes, Graphics, Controls, Forms,
  Dialogs, DB, SaDb, Grids, DBGrids, ExtCtrls, StdCtrls, Buttons, Contnrs,
  SaCommon;

type

  TForm1 = class(TForm)
    SaDb1: TSaDb;
    SaDs1: TSaDs;
    SaDs2: TSaDs;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    DBGrid2: TDBGrid;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Timer1: TTimer;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SaDb1ConnDropped(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Connect;
  end;

var
  Form1: TForm1;

implementation

uses
  Unit2, Unit3;

{$r *.dfm}

procedure TForm1.Connect;
begin
  Show;
  with TForm2.Create( Self )
  do  begin
      try
        while true
        do  begin
            if ShowModal = mrOk
            then  begin
                  try
                    AssignParamsToSaDb( SaDb1 );
                    SaDb1.Active := true;
                    break;
                  except
                    on e : exception
                    do  begin
                        ShowMessage( 'Connection error:'
                          + #10 + #13 + e.Message );
                        end;
                  end;
                  end
            else  break;
            end;
      finally
        Free;
      end;
      end;
  if SaDb1.Active
  then  begin
        SaDs1.Active := true;
        end
  else  Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaDb1.Active := false;
  Release;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  if not SaDs1.IsEmpty
  then  begin
        SaDs2.TblNames := SaDs1.FieldByName( 'table_name' ).AsString;
        SaDs2.Active := true;
        end
  else  SaDs2.Active := false;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  Timer1.Enabled := false;
  Timer1.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with TForm3.Create( nil )
  do  begin
      SaDs1.SaDb := SaDb1;
      ShowModal;
      Free;
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  with TForm1.Create( Application.MainForm ) do Connect;
end;

procedure TForm1.SaDb1ConnDropped(Sender: TObject);
begin
  MessageBox( Handle, 'Connection was dropped', 'Information!',
    MB_OK or MB_ICONINFORMATION );
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  BitBtn2.Enabled := CheckBox1.Checked;
  BitBtn3.Enabled := CheckBox1.Checked;
  SaDs2.Cached := CheckBox1.Checked;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  SaDs2.SaDb.TransactStart;
  try
    SaDs2.ApplyCache;
    SaDs2.SaDb.TransactCommit;
  except
    SaDs2.SaDb.TransactRollback;
    raise;
  end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  SaDs2.CancelCache;
end;

end.
