unit Unit2;

{$i SaDemo.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  {$ifdef D_67}Variants, {$endif} StdCtrls, ExtCtrls,
  Dialogs, SaDb, SaCommon, Registry;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit4: TEdit;
    Label10: TLabel;
    Edit5: TEdit;
    Label11: TLabel;
    Edit6: TEdit;
    Label9: TLabel;
    Edit7: TEdit;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Label12: TLabel;
    Edit8: TEdit;
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    oDemos : TStringList;
    function FindSybase( iVer : TSaVersion; var sDemo : string ) : string;
    procedure ActivateSybase( iIndex : integer );
  public
    { Public declarations }
    procedure AssignParamsToSaDb( oSaDb : TSaDb );
  end;

implementation

{$R *.dfm}

const
  AS_ASADEMO : array[ TSaVersion ] of string =
    ( 'sademo.db', 'asademo.db', 'asademo.db', 'asademo.db', 'asademo.db',
      'demo.db' );
  AS_LOCALSERVERNAMES : array[ TSaVersion ] of string =
    ( 'sa_demo_50', 'sa_demo_60', 'sa_demo_70', 'sa_demo_80', 'sa_demo_90',
      'sa_demo_100' );

procedure TForm2.FormCreate(Sender: TObject);
var
  i : TSaVersion;
  s, sDemo : string;
begin
  oDemos := TStringList.Create;
  RadioGroup1Click( nil );
  for i := Low( i ) to High( i )
  do  begin
      s := FindSybase( i, sDemo );
      if s <> ''
      then  begin
            ListBox1.Items.Objects[ ListBox1.Items.Add( s ) ] := TObject( i );
            oDemos.Add( sDemo );
            end;
      end;
  if ListBox1.Items.Count > 0 then ActivateSybase( 0 );
end;

procedure TForm2.RadioGroup1Click(Sender: TObject);
begin
  Edit4.Visible := RadioGroup1.ItemIndex = 0;
  Label8.Visible := Edit4.Visible;
  Edit5.Visible := RadioGroup1.ItemIndex = 1;
  Label10.Visible := Edit5.Visible;
  Edit6.Visible := RadioGroup1.ItemIndex = 1;
  Label11.Visible := Edit6.Visible;
  Edit7.Visible := RadioGroup1.ItemIndex = 2;
  Label9.Visible := Edit7.Visible;
end;

procedure TForm2.AssignParamsToSaDb;
var
  iVer : TSaVersion;
begin
  iVer := TSaVersion( ComboBox1.ItemIndex );
  oSaDb.SaVersion := iVer;
  oSaDb.SaSysDllPath := Edit1.Text;
  oSaDb.ConnectParams.Agent := TSaAgent( RadioGroup1.ItemIndex );
  oSaDb.ConnectParams.LoginUid := Edit2.Text;
  oSaDb.ConnectParams.LoginPwd := Edit3.Text;
  oSaDb.ConnectParams.DatabaseFile := Edit4.Text;
  oSaDb.SharedName := Edit8.Text;
  if oSaDb.ConnectParams.Agent = saLocal
  then  oSaDb.ConnectParams.ServerName := AS_LOCALSERVERNAMES[ oSaDb.SaVersion ]
  else  oSaDb.ConnectParams.ServerName := Edit5.Text;
  oSaDb.ConnectParams.DatabaseName := Edit6.Text;

  if oSaDb.ConnectParams.Agent = saCustom
  then  oSaDb.ConnectParams.ConnectParamStr := Edit7.Text
  else  oSaDb.ConnectParams.ConnectParamStr := '';
end;

function TForm2.FindSybase;
const
  AS_REG : array[ TSaVersion ] of string =
    (
      'Software\Sybase\SQL Anywhere\Sybase SQL Anywhere 5.0',
      'Software\Sybase\Adaptive Server Anywhere\6.0',
      'Software\Sybase\Adaptive Server Anywhere\7.0',
      'Software\Sybase\Adaptive Server Anywhere\8.0',
      'Software\Sybase\Adaptive Server Anywhere\9.0',
      'Software\Sybase\SQL Anywhere\10.0'
    );

var
  oReg : TRegistry;
begin
  result := '';
  oReg := TRegistry.Create;
  try
    case iVer of
      sa50, sa60, sa70, sa80, sa90, sa100 :
        begin
        oReg.RootKey := HKEY_LOCAL_MACHINE;
        if oReg.OpenKeyReadOnly( AS_REG[ iVer ] )
        then  result := oReg.ReadString( 'Location' );
        if result = ''
        then  begin
              oReg.RootKey := HKEY_CURRENT_USER; oReg.OpenKeyReadOnly( '' );
              if oReg.OpenKeyReadOnly( AS_REG[ iVer ] )
              then  result := oReg.ReadString( 'Location' );
              end;
        end;
    end;
    if result <> ''
    then  begin
          result := result + '\';
          case iVer of
            sa100 :
              begin
              sDemo := oReg.ReadString( 'Samples Location' );
              if sDemo <> ''
              then  begin
                    sDemo := IncludeTrailingPathDelimiter( sDemo ) +
                      AS_ASADEMO[ iVer ];
                    end;
              end;
          else
            sDemo := result + AS_ASADEMO[ iVer ];
          end;
          end;
  finally
    oReg.Free;
  end;

end;

procedure TForm2.ActivateSybase;
var
  iVer : TSaVersion;
begin
  iVer := TSaVersion( ListBox1.Items.Objects[ iIndex ] );
  Edit1.Text := ListBox1.Items[ iIndex ] + 'win32\';
  Edit4.Text := oDemos[ iIndex ];
  Combobox1.ItemIndex := integer( iVer );
end;

procedure TForm2.ListBox1DblClick(Sender: TObject);
begin
  if ( ListBox1.Items.Count > 0 ) and ( ListBox1.ItemIndex >= 0 )
  then  ActivateSybase( ListBox1.ItemIndex );
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  oDemos.Free;
end;

end.
