{* SaVcl 2.5.  SaCommon.pas. Serge Gavrilov ( C ) 2003 - 2006 *************** *}

unit SaCommon;

{$i SaInc.inc}

{$ifdef D_67}
  {$A8}
{$endif}

interface

uses
  Db;

type
  TSaVersion = ( sa50, sa60, sa70, sa80, sa90, sa100 );
  TSaAgent = ( saLocal, saNetwork, saCustom );
  TSaLink = ( slAll, slIpx, slNamedPipes, slNetBios, slNone, slShMem,
    slSpx, slTcpIp );
  TSaLinks = set of TSaLink;
  TSaOption = ( soNoAutoStop );
  TSaOptions = set of TSaOption;
  TSaMsgType = ( smInfo, smWarning, smAction, smStatus );
  TSaDbOption = ( doSaTransactions, doSequenced );
  TSaDbOptions = set of TSaDbOption;
  TSaTranslator = ( stNone, stCp866 );

const
  SA_S_VCLPAGENAME = 'SaVcl';
  SA_S_NL = #13 + #10;



                                                                                

  SQLE_NOERROR = 0;
  SQLE_NOTFOUND = 100;
  SQLE_VALUE_TRUNCATED = 101;
  SQLE_NO_CURRENT_ROW = -197;
  SQLE_ROW_UPDATED_WARNING = 104;
  SQLE_PROCEDURE_COMPLETE = 105;

  SQL_MAX_NAME_LEN = 30;
  SQL_NULL_MASK = $FFFE;

  DT_NOTYPE = 0;
  DT_VARCHAR = 448;
  DT_FIXCHAR = 452;
  DT_LONGVARCHAR = 456;
  DT_STRING = 460;
  DT_DOUBLE = 480;
  DT_FLOAT = 482;
  DT_DECIMAL = 484;
  DT_INT = 496;
  DT_SMALLINT = 500;
  DT_BINARY = 524;
  DT_LONGBINARY = 528;
  DT_DATE = 384;
  DT_TIME = 388;
  DT_TIMESTAMP_STRUCT = 390;
  DT_TIMESTAMP = 392;
  DT_VARIABLE = 600;
  DT_TINYINT = 604;
  DT_BIGINT = 608;
  DT_UNSINT = 612;
  DT_UNSSMALLINT = 616;
  DT_UNSBIGINT = 620;
  DT_BIT = 624;

  DT_UPDATABLE = $2000 ;
  DT_DESCRIBE_INPUT = $1000 ;
  DT_PROCEDURE_IN = $4000 ;
  DT_PROCEDURE_OUT = $8000 ;
  DT_AUTO_INCREMENT = $0800 ;
  DT_KEY_COLUMN = $0400 ;
  DT_HIDDEN_COLUMN = $0200 ;
  DT_HAS_USERTYPE_INFO = $0100 ;
  DT_PARAM_INPUT = DT_DESCRIBE_INPUT OR DT_PROCEDURE_IN;

  DB_CALLBACK_START = 0;
  DB_CALLBACK_WAIT = 1;
  DB_CALLBACK_FINISH = 2;
  DB_CALLBACK_ASYNC_RESPONSE = 3;
  DB_CALLBACK_TRANSLATE_IN = 4;
  DB_CALLBACK_TRANSLATE_OUT = 5;
  DB_CALLBACK_UNKNOWN_EVENT = 6;
  DB_CALLBACK_MESSAGE = 7;
  DB_CALLBACK_CONN_DROPPED = 8;
  DB_CALLBACK_DEBUG_MESSAGE = 9;
  DB_MAX_CALLBACK = 10;

  MESSAGE_TYPE_INFO	= 0;
  MESSAGE_TYPE_WARNING = 1;
  MESSAGE_TYPE_ACTION	= 2;
  MESSAGE_TYPE_STATUS = 3;

  SA_MAX_NAME = 31;
  SA_MAX_STR = 3000;
  SA_MAXDATA_LEN = 32764;
  
  SA_CURSOPT_DYNSCROLL = 1;
  SA_CURSOPT_NOSCROLL = 2;
  SA_CURSOPT_INSENSITIVE = 4;
  SA_CURSOPT_FORREADONLY = 8;

  SA_VAR_CREATE = 0;
  SA_VAR_DROP = 1;

  SA_TRANS_ROLLBACK = 0;
  SA_TRANS_COMMIT = 1;
  SA_TRANS_START = 2;
  SA_CURSCHANGE_INSERT = 1;
  SA_CURSCHANGE_UPDATE = 2;
  SA_CURSCHANGE_DELETE = 3;

type

  TSaDbMessage = record
    iMsgType : integer;
    iCode : integer;
    iLength : integer;
    szMessage : PChar;
  end;
  TPSaDbMessage = ^TSaDbMessage;

const
  SA_RES_OK = 0;
  SA_RES_ERROR = -1;
  SA_RES_CHECKERR = -2;
  SA_RES_NOTDATA = -3;
  SA_RES_INIT_NOTSYSDLL = -4;
  SA_RES_INIT_WRONGVERSION = -5;

type
  TSaOrderFldOpt = ( ofoKey,
    ofoDesc );
  TSaOrderFldOpts = set of TSAOrderFldOpt;

  TSaLocateOpt = ( loPartLeft,
    loPartAny,
    loUp,
    loDown,
    loNullStrings
  );
  TSaLocateOpts = set of TSaLocateOpt;


const
  SA_SERV_ISNULL = 1;
  SA_SERV_VLREC = 2;
  SA_VLREC_ISNULL = -1;


type
  TFLDDesc = record
    iFldNum : integer;
    sFldName : string;
    iOffset : integer;
    iBufLen : integer;
    iFldType : TFieldType;
    iFldSize : integer;
    iFldPrec : integer;
    isVLRec : boolean;
    isAllowNulls : boolean;
    isNoUpdate : boolean;
    iAddData : integer;
    pAddData : pointer;
  end;
  TPFLDDesc = ^TFLDDesc;
  TFldDescs = array[ 0..1023 ] of TFLDDesc;
  TPFldDescs = ^TFldDescs;


  Ta_sql_statement_number = SmallInt;
  TPa_sql_statement_number = ^Ta_sql_statement_number;
  TSqlNameRec = record
    iLength : SmallInt;
    sData : packed array[ 0..SQL_MAX_NAME_LEN - 1 ] of char;
  end;
  PSmallInt= ^SmallInt;

  TSqlVarRec = record
    iSqlType : SmallInt;
    iSqlLen : SmallInt;
    pSqlData : Pointer;
    pSqlInd : PSmallInt;
    rcSqlName : TSqlNameRec;
  end;
  TPSqlVarRec = ^TSqlVarRec;

  TSqldaRec = record
    sSqldaId : array[ 0..7 ] of char;
    iSqldaBC : Longint;
    iSqln : SmallInt;
    iSqld : SmallInt;
    arSqlVar : array[ 0..1024 ] of TSqlVarRec;
  end;
  TPSqldaRec = ^TSqldaRec;
  TPPSqldaRec = ^TPSqldaRec;

  TSaConnectContext = pointer;
  TPSaConnectContext = ^TSaConnectContext;
  TSADTRec = packed record
    iYear : SmallInt;
    bMonth : Byte;
    bDayOfWeek : Byte;
    bDayOfYear : SmallInt;
    bDay : Byte;
    bHour : Byte;
    bMinute : Byte;
    bSecond : Byte;
    iMicroSecond : LongInt;
  end;
  TVarCharRec = record
    iLen : word;
    sChar : array[ 1..1 ] of Char;
  end;
  TBinaryRec = record
    iLen : word;
    sChar : array[ 1..1 ] of Char;
  end;


  TPVLRec = ^TVLRec;
  TVLRec = record
    iData : integer;
    pData : pointer;
  end;

  TFetchResult = (
      frOK,
      frNotFound,
      frNoCurrentRow,
      frUpdateWarning
    );

implementation

end.


