{* SaVcl 2.5.  SaDbBase.pas. Serge Gavrilov ( C ) 2003 - 2006 *************** *}

unit SaDbBase;

{$i SaInc.inc}

{ unit description

}

interface

uses
  Windows, Classes, SysUtils, Db,
{$ifdef D_67}
  Variants, FmtBcd,
{$else}
{$endif}
  SaCommon, SaConsts, SaUtils;

type
  TDebMsgFunc = function(
      pCC : TSaConnectContext;
      szBuff : PChar;
      iBuff : integer
    ) : integer; stdcall;
  TLastErrorFunc = function(
      pCC : TSaConnectContext;
      szBuff : PChar;
      iBuff : integer
    ) : integer; stdcall;
  TGetSqlCount = function(
      pCC : TSaConnectContext
    ) : integer; stdcall;
  TLoadDllFunc = function(
      isLoad : BOOL;
      szLibName : PChar
    ) : integer; stdcall;
  TConnectFunc = function(
      isConnect : BOOL;
      ppCC : TPSaConnectContext;
      szConnectName : PChar;
      szParams : PChar;
      szSharedName : PChar;
      iUserData : integer;
      pCallBack : pointer
    ) : integer; stdcall;
  TTransactFunc = function(
      pCC : TSaConnectContext;
      iWhat : integer
    ) : integer; stdcall;
  TPrepareFunc = function(
      pCC : TSaConnectContext;
      szSQL : PChar;
      piStat : TPa_sql_statement_number
    ) : integer; stdcall;
  TUnPrepareFunc = function(
      pCC : TSaConnectContext;
      iStat : Ta_sql_statement_number
    ) : integer; stdcall;
  TDeclareFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar;
      iStat : Ta_sql_statement_number;
      iCursorOptions : integer
    ) : integer; stdcall;
  TOpenFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar;
      pInput : TPSqldaRec
    ) : integer; stdcall;
  TCloseFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar
    ) : integer; stdcall;
  TFetchFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar;
      pOutSQLDA : TPSqldaRec;
      isAbs : BOOL;
      iAbsRel : integer
    ) : integer; stdcall;
  TChangeFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar;
      iWhat : integer;
      pSQLDA : TPSqldaRec;
      pOutSQLDA : TPSqldaRec
    ) : integer; stdcall;
  TDescribeFunc = function(
      pCC : TSaConnectContext;
      isDescribeInput : BOOL;
      szCursName : PChar;
      iStat : Ta_sql_statement_number;
      ppSqlda : TPPSqldaRec
    ) : integer; stdcall;
  TFillDaFunc = function(
      pCC : TSaConnectContext;
      pSQLDA : TPSqldaRec
    ) : integer; stdcall;
  TFreeFilledDaFunc = function(
      pSQLDA : TPSqldaRec
    ) : integer; stdcall;
  TExecFunc = function(
      pCC : TSaConnectContext;
      iStat : Ta_sql_statement_number;
      pInput : TPSqldaRec;
      pOutput : TPSqldaRec
    ) : integer; stdcall;
  TExecImmFunc = function(
      pCC : TSaConnectContext;
      szSQL : PChar
    ) : integer; stdcall;
  TGetDataFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar;
      iCol : integer;
      pDest : pointer;
      pCallBack : pointer;
      iTrans : integer
    ) : integer; stdcall;
  TSetFunc = function(
      pCC : TSaConnectContext;
      iWhat : integer;
      szVarName : PChar;
      isBinary : BOOL;
      oSrc : pointer;
      iSrc : integer;
      pCallBack : pointer;
      pUserData : pointer
    ) : integer; stdcall;
  TCancelRequestFunc = function  (
      pCC : TSaConnectContext
    ) : integer; stdcall;
  TGetIdentityFunc = function(
      pCC : TSaConnectContext;
      szResult : pointer;
      iResultLen : integer
    ) : integer; stdcall;
  TResumeFunc = function(
      pCC : TSaConnectContext;
      szCursName : PChar
    ) : integer; stdcall;

  TSaDllRec = record
    iHandle : THandle;

    fnLoadDLL : TLoadDllFunc;
    fnGetSqlCount : TGetSqlCount;
    fnFetch : TFetchFunc;
    fnGetLastError : TLastErrorFunc;
    fnGetDebMsg : TDebMsgFunc;
    fnConnect : TConnectFunc;
    fnTransact : TTransactFunc;
    fnPrepare : TPrepareFunc;
    fnUnPrepare : TUnPrepareFunc;
    fnDeclare : TDeclareFunc;
    fnOpen : TOpenFunc;
    fnClose : TCloseFunc;
    fnChange : TChangeFunc;
    fnFillDa : TFillDaFunc;
    fnFreeFilledDa : TFreeFilledDaFunc;
    fnExec : TExecFunc;
    fnExecImm : TExecImmFunc;
    fnDescribe : TDescribeFunc;
    fnGetData : TGetDataFunc;
    fnSet : TSetFunc;
    fnCancelRequest : TCancelRequestFunc;
    fnGetIdentity : TGetIdentityFunc;
    fnResume : TResumeFunc;
  end;
  TPSaDllRec = ^TSaDllRec;

{* ************************************************************************** *}

  TSaConnectParams = class( TPersistent )
  private
    sConnectParamStr : string;
    sUid : string;
    sPwd : string;
    sDbf : TFileName;
    sEng : string;
    sDbn : string;
    iAgent : TSaAgent;
    iLinks : TSaLinks;
    iOptions : TSaOptions;
    function GetConnectParams( sSysPath : string; iVer : TSaVersion ) : string;
  public
    constructor Create;
  published
    property LoginUid : string read sUid write sUid;
    property LoginPwd : string read sPwd write sPwd;
    property DatabaseFile : TFileName read sDbf write sDbf;
    property DatabaseName : string read sDbn write sDbn;
    property ServerName : string read sEng write sEng;
    property ConnectParamStr : string read sConnectParamStr
      write sConnectParamStr;
    property Agent : TSaAgent read iAgent write iAgent;
    property Links : TSaLinks read iLinks write iLinks;
    property Options : TSaOptions read iOptions write iOptions;
  end;

{* ************************************************************************** *}
  TSaDbWaitFunc = function( isCanCancel : boolean ) : boolean of object;
  TSaDbMessage = procedure( iMsgType : TSaMsgType; iCode : integer;
    sMsg : string ) of object;
  TSaDbDebugMessage = procedure( const sDebMsg : string ) of object;
  TSaDbConnDropped = procedure of object;
  TSaDbStart = procedure of object;
  TSaDbFinish = procedure of object;
  TSaDbBase = class
  private
    pDllRec : TPSaDllRec;
    iVer : TSaVersion;
    sSaSysDllPath : string;
    sSharedName : string;
    sLinkDllName : string;

    iOptions : TSaDbOptions;
    isActive : boolean;
    oConnectParams : TSaConnectParams;
    isOnTransact : boolean;
    pCC : TSaConnectContext;
    isCaseSens : boolean;
    isSequenced : boolean;
    isUseDtString : boolean;
    oMonClient : THWNDConnect;
    iTranslator : TSaTranslator;
    mOnWait : TSaDbWaitFunc;
    mOnMessage : TSaDbMessage;
    mOnDebugMessage : TSaDbDebugMessage;
    mOnConnDropped : TSaDbConnDropped;
    mOnStart : TSaDbStart;
    mOnFinish : TSaDbFinish;
    procedure SetSequenced( isVal : boolean );
    function GetTranslatorNum : integer;
    procedure DoTransact(
        iWhat : integer );
    function GetConnectParams : string;
    procedure InitLinkDll;
    procedure DeInitLinkDll;
    procedure SetSaVersion( iVal : TSaVersion );
    procedure SetSaSysDllPath( const sVal : string );
    procedure SetSharedName( const sVal : string );
    procedure SetLinkDllName( const sVal : string );
    procedure CAR(
        iRes : integer;
        isRaiseException : boolean = true );
    procedure ProcessCallBack (
        iIndex : integer;
        pData : pointer );
    procedure SQLM_SendQuery( oSaDsBase : TObject; isPrepared : boolean;
      pBind : TPSqldaRec; const sStat : string );
    procedure SetActive( isVal : boolean );
    procedure SetConnectParams( oVal : TSaConnectParams );

    function Wait( isCanCancel : boolean ) : boolean;
    procedure DoDbMessage( pDbMessage : TPSaDbMessage );
    function IsSaTransact : boolean;
  public
    constructor Create;
    destructor Destroy; override;
    procedure BeginSequence;
    procedure EndSequence;
    function GetSQLCount : integer;
    procedure SQLM_PreparedQuery(
        oSaDsBase : TObject;
        pBind : TPSqldaRec;
        const sStat : string );
    procedure SQLM_Query(
        oSaDsBase : TObject;
        const sStat : string );
    procedure TransactStart;
    procedure TransactCommit;
    procedure TransactRollBack;
    procedure TransactAutoCommit;
    procedure TransactAutoRollBack;
    procedure CreateLongVar(
        const sVarName : string;
        oStream : TStream;
        iSize : integer;
        isBinary : boolean );
    procedure DropLongVar(
        const sVarName : string );
    procedure PutVeryLongData(
        oStream : TStream;
        isBinary : boolean;
        iSize : integer;
        const sTableName : string;
        const sFieldName : string;
        const sWhereCondition : string );
    function CancelRequest
        : boolean;
    procedure SaPrepare(
        szSQL : PChar;
        piStat : TPa_sql_statement_number );
    procedure SaUnPrepare(
        iStat : Ta_sql_statement_number );
    procedure SaDeclare(
        szCursName : PChar;
        iStat : Ta_sql_statement_number;
        iCursorOpts : integer );
    procedure SaOpen(
        szCursName : PChar;
        pInput : TPSqldaRec );
    procedure SaClose(
        szCursName : PChar );
    function SaFetch(
        szCursName : PChar;
        pOutSQLDA : TPSqldaRec;
        isAbs : boolean;
        iAbsRel : integer
      ) : TFetchResult;
    procedure SaChange(
        szCursName : PChar;
        iWhat : integer;
        pSQLDA : TPSqldaRec;
        pOutSQLDA : TPSqldaRec );
    procedure SaDescribe(
        isDescribeInput : boolean;
        szCursName : PChar;
        iStat : Ta_sql_statement_number;
        ppSqlda : TPPSqldaRec );
    procedure SaFillDa(
        pSqlda : TPSqldaRec );
    procedure SaFreeFilledDa(
        pSqlda : TPSqldaRec );
    function GetIdentity : string;
    procedure SaExec(
        iStat : Ta_sql_statement_number;
        pInput : TPSqldaRec;
        pOutput : TPSqldaRec );
    procedure SaExecImm(
        szSQL : PChar );
    procedure SaGetData(
        szCursName : PChar;
        iCol : integer;
        pDest : pointer;
        pCallBack : pointer;
        iTransl : integer );
    function GetDebMsg : string;
    function SaResume(
        szCursName : PChar        
      ) : boolean;
    property SaSysDllPath : string read sSaSysDllPath write SetSaSysDllPath;
    property SharedName : string read sSharedName write SetSharedName;
    property LinkDllName : string read sLinkDllName write SetLinkDllName;
    property ConnectParams : TSaConnectParams read oConnectParams
      write SetConnectParams;
    property SaVersion : TSaVersion read iVer write SetSaVersion;
    property Active : boolean read isActive write SetActive default false;
    property CaseSensitive : boolean read isCaseSens;
    property UseDtString : boolean read isUseDtString;
    property Options : TSaDbOptions read iOptions write iOptions;
    property OnWait : TSaDbWaitFunc read mOnWait write mOnWait;
    property OnMessage : TSaDbMessage read mOnMessage write mOnMessage;
    property OnDebugMessage : TSaDbDebugMessage read mOnDebugMessage
      write mOnDebugMessage;
    property OnConnDropped : TSaDbConnDropped read mOnConnDropped
      write mOnConnDropped;
    property OnStart : TSaDbStart read mOnStart write mOnStart;
    property OnFinish : TSaDbFinish read mOnFinish write mOnFinish;
    property Translator : TSaTranslator read iTranslator write iTranslator;
    property TranslatorNum : integer read GetTranslatorNum;
  end;

{* ************************************************************************** *}

implementation

uses
  SaDsBase;

const
  AS_LINKDLL : array[ TSaVersion ] of string =
    ( 'sadll50.dll', 'sadll60.dll', 'sadll70.dll',
      'sadll80.dll', 'sadll90.dll', 'sadll100.dll' );

{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function SaCallBack(
    iUserData : integer;
    iIndex : integer;
    pCallBackData : pointer
  ) : integer;  stdcall;
begin
  TSaDbBase( iUserData ).ProcessCallBack( iIndex, pCallBackData );
  result := SA_RES_OK;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function SaLoadLinkDll(
    sLibName : string;
    sSaLibPath : string;
    var pDllRec : TPSaDllRec
  ) : integer;
  procedure SaFreeLinkDll;
  begin
    FreeLibrary( pDllRec^.iHandle );
    FreeMem( pDllRec, sizeof( pDllRec^ ) );
    pDllRec := nil;
  end;
var
  iHandle   : THandle;
begin
  iHandle := LoadLibrary( PChar( sLibName ) );
  if iHandle = 0
  then  begin
        iHandle := LoadLibrary( PChar( sSaLibPath + '\' + sLibName ) );
        if iHandle = 0
        then  begin
              result := SA_RES_NOTDATA;
              exit;
              end;
        end;

  GetMem( pDllRec, sizeof( pDllRec^ ) );
  ZeroMemory( pDllRec, sizeof( pDllRec^ ) );
  pDllRec^.iHandle := iHandle;
  with pDllRec^
  do  begin
      fnLoadDLL := GetProcAddress( pDllRec^.iHandle, 'sa_init_dll' );
      fnGetSqlCount := GetProcAddress( pDllRec^.iHandle, 'sa_getsqlcount' );
      fnConnect := GetProcAddress( pDllRec^.iHandle, 'sa_connect' );
      fnGetLastError := GetProcAddress( pDllRec^.iHandle, 'sa_getlasterror' );
      fnGetDebMsg := GetProcAddress( pDllRec^.iHandle, 'sa_getdebmsg' );
      fnTransact := GetProcAddress( pDllRec^.iHandle, 'sa_transact' );
      fnPrepare := GetProcAddress( pDllRec^.iHandle, 'sa_prepare' );
      fnUnPrepare := GetProcAddress( pDllRec^.iHandle, 'sa_unprepare' );
      fnDeclare := GetProcAddress( pDllRec^.iHandle, 'sa_declare' );
      fnOpen := GetProcAddress( pDllRec^.iHandle, 'sa_open' );
      fnClose := GetProcAddress( pDllRec^.iHandle, 'sa_close' );
      fnFetch := GetProcAddress( pDllRec^.iHandle, 'sa_fetch' );
      fnChange := GetProcAddress( pDllRec^.iHandle, 'sa_curschange' );
      fnFillDa := GetProcAddress( pDllRec^.iHandle, 'sa_fillda' );
      fnFreeFilledDa := GetProcAddress( pDllRec^.iHandle, 'sa_freefilledda' );
      fnExec := GetProcAddress( pDllRec^.iHandle, 'sa_exec' );
      fnExecImm := GetProcAddress( pDllRec^.iHandle, 'sa_execimm' );
      fnDescribe := GetProcAddress( pDllRec^.iHandle, 'sa_describe' );
      fnGetData := GetProcAddress( pDllRec^.iHandle, 'sa_getdata' );
      fnSet := GetProcAddress( pDllRec^.iHandle, 'sa_set' );
      fnCancelRequest:= GetProcAddress( pDllRec^.iHandle, 'sa_cancel_request' );
      fnGetIdentity := GetProcAddress( pDllRec^.iHandle, 'sa_getidentity' );
      fnResume := GetProcAddress( pDllRec^.iHandle, 'sa_resume' );
      end;
  if ( not Assigned( pDllRec^.fnLoadDLL ) )
    or ( not Assigned( pDllRec^.fnGetSqlCount ) )
    or ( not Assigned( pDllRec^.fnConnect ) )
    or ( not Assigned( pDllRec^.fnGetLastError ) )
    or ( not Assigned( pDllRec^.fnGetDebMsg ) )
    or ( not Assigned( pDllRec^.fnTransact ) )
    or ( not Assigned( pDllRec^.fnPrepare ) )
    or ( not Assigned( pDllRec^.fnUnPrepare ) )
    or ( not Assigned( pDllRec^.fnOpen ) )
    or ( not Assigned( pDllRec^.fnClose ) )
    or ( not Assigned( pDllRec^.fnDescribe ) )
    or ( not Assigned( pDllRec^.fnFetch ) )
    or ( not Assigned( pDllRec^.fnChange ) )
    or ( not Assigned( pDllRec^.fnFillDa ) )
    or ( not Assigned( pDllRec^.fnFreeFilledDa ) )
    or ( not Assigned( pDllRec^.fnExec ) )
    or ( not Assigned( pDllRec^.fnExecImm ) )
    or ( not Assigned( pDllRec^.fnDescribe ) )
    or ( not Assigned( pDllRec^.fnGetData ) )
    or ( not Assigned( pDllRec^.fnSet ) )
    or ( not Assigned( pDllRec^.fnCancelRequest ) )
    or ( not Assigned( pDllRec^.fnGetIdentity ) )
    or ( not Assigned( pDllRec^.fnResume ) )
  then  result := SA_RES_NOTDATA
  else  begin
        try
          result := pDllRec^.fnLoadDLL( true, PChar( sSaLibPath ) );
          if result <> SA_RES_OK then  SaFreeLinkDll;
        except
          on E : exception
          do  begin
              SaFreeLinkDll;
              raise;
              end;
        end;
        end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure SaFreeLinkDll( pDllRec : TPSaDllRec );
begin
  if pDllRec = nil then exit;
  pDllRec^.fnLoadDll( false, nil );
  FreeLibrary( pDllRec^.iHandle );
  FreeMem( pDllRec, sizeof( pDllRec^ ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}

{* ************************************************************************** *}

{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
constructor TSaConnectParams.Create;
begin
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaConnectParams.GetConnectParams;
const
  AS_DBENG : array[ TSaVersion ] of string =
    ( 'dbeng50.exe', 'dbeng6.exe', 'dbeng7.exe', 'dbeng8.exe', 'dbeng9.exe',
      'dbeng10.exe' );
  AS_LINK : array[ TSaLink ] of string =
    ( 'all', 'ipx', 'np', 'netbios', 'none', 'shmem', 'spx', 'tcpip' );
  AS_AGENT : array[ TSaAgent ] of string =
    ( 'engine', 'client', '' );

  procedure AddParam( sParam : string; var sResult : string );
  begin
    if ( sResult <> '' ) and ( sParam <> '' ) then  sResult := sResult + ';';
    sResult := sResult + sParam;
  end;

  procedure AddLink( iLink : TSaLink; var sLinks : string );
  begin
    if sLinks <> '' then sLinks := sLinks + ',';
    sLinks := sLinks + AS_LINK[ iLink ];
  end;

var
  iLink : TSaLink;
  sLinks, sParam : string;
begin
  result := '';
  if ( sSysPath <> '' ) and ( sSysPath[ Length( sSysPath ) ] <> '\' )
  then  sSysPath := sSysPath + '\';
  if sUid <> '' then AddParam( 'uid=' + sUid, result );
  if sPwd <> '' then AddParam( 'pwd=' + sPwd, result );
  if soNoAutoStop in iOptions then AddParam( 'autostop=no', result );
  case iAgent of
    saLocal :
      begin
      if sEng <> '' then AddParam( 'eng=' + sEng, result );
      if sDbf <> '' then AddParam( 'dbf=' + sDbf, result );
      if not ( iVer in [ sa90, sa100 ] )
      then  AddParam( 'agent=' + AS_AGENT[ iAgent ], result );
      AddParam( 'start=' + sSysPath + AS_DBENG[ iVer ], result );
      end;
    saNetwork :
      begin
      if sEng <> '' then AddParam( 'eng=' + sEng, result );
      if sDbn <> '' then AddParam( 'dbn=' + sDbn, result );
      if sDbf <> '' then AddParam( 'dbf=' + sDbf, result );
      sLinks := '';
      for iLink := Low( iLink ) to High( iLink )
      do  if iLink in iLinks then AddLink( iLink, sLinks );
      if iVer = sa50
      then  begin
            sParam := 'start=' + sSysPath + 'dbclient';
            if sLinks <> '' then sParam := sParam + ' -x ' + sLinks;
            AddParam( sParam, result );
            end
      else  begin
            if sLinks <> '' then AddParam( 'links=' + sLinks, result );
            end;
      end;
    saCustom :
      begin
      end;
  end;
  AddParam( sConnectParamStr, result );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}

{* ************************************************************************** *}

{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
constructor TSaDbBase.Create;
begin
  inherited;
  oConnectParams := TSaConnectParams.Create;
  oMonClient := THWNDConnect.Create( nil );
  oMonClient.Server := false;
  oMonClient.FileMap := 'GSVSASQLMonitor';
  iVer := sa70;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
destructor TSaDbBase.Destroy;
begin
  Active := false;
  oMonClient.Free; oMonClient := nil;
  DeInitLinkDll;
  oConnectParams.Free;
  inherited;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.CAR;
var
  sMess       : string;
  iSQLCode    : integer;
  iExcType    : TSAExceptionType;
begin
  iSQLCode := 0;
  iExcType := eInternal;
  case iRes of
    SA_RES_OK : ;
    SA_RES_CHECKERR
    : begin
      SetLength( sMess, SA_MAX_STR );
      FillChar( sMess[ 1 ], SA_MAX_STR, ' ' );
      iSQLCode := pDllRec^.fnGetLastError( pCC, PChar( sMess ), SA_MAX_STR );
      sMess := Trim( sMess );
      iExcType := eSyBase;
      end;
    SA_RES_ERROR : sMess := SA_S_ERR_COMMON;
    SA_RES_NOTDATA : sMess := SA_S_ERR_NOTDATA;
  else  sMess := SA_S_ERR_UNKNOWN;
  end;
  if ( iRes <> SA_RES_OK ) and isRaiseException
  then raise SaException.Create( iExcType, iSQLCode, sMess );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetActive;
  procedure Tuning;
  var
    oDs : TSaDsBase;
    vTmp : variant;
  begin
    oDs := TSaDsBase.Create;
    try


      oDs.SaDbBase := Self;
      oDs.OpenCurs(
        'select case_sensitivity, blank_padding, ' +
          'cast( "connection_property"( ''row_counts'' ) as char( 10 ) ) ' +
            'from sys.sysinfo',
          SA_CURSOPT_NOSCROLL, nil );
      oDs.Fetch( true, false, 1 );
      oDs.GetSQLDABuf( true, true, 0, false, nil, @vTmp, 0 );
      isCaseSens := CompareText( vTmp, 'y' ) = 0;
      oDs.GetSQLDABuf( true, true, 1, false, nil, @vTmp, 0 );
      isUseDtString := CompareText( vTmp, 'n' ) = 0;
      oDs.GetSQLDABuf( true, true, 2, false, nil, @vTmp, 0 );
      isSequenced := ( vTmp <> null ) and ( CompareText( vTmp, 'on' ) = 0 );
      oDs.CloseCurs;

      if not ( iVer in [ sa50, sa60 ] )
      then  oDs.ExecStatmImm( 'SET OPTION ANSI_UPDATE_CONSTRAINTS = ''OFF''' );

      if ( iVer in [ sa100 ] )
      then  oDs.ExecStatmImm( 'SET OPTION string_rtruncation = ''OFF''' );

      if ( not isSequenced ) and ( doSequenced in Options )
      then  SetSequenced( true );

    finally
      oDs.Free;
    end;
  end;
var
  wH, wM, wS, wMs : word;
  sDbName : string;
begin
  if isVal <> isActive
  then  begin
          if not isVal
          then  begin
                isActive := false;
                try
                  CAR( pDllRec^.fnConnect( false, @pCC, nil, nil, nil,
                    integer( Self ), @SaCallBack ) );
                except
                end;
                end
          else  begin
                InitLinkDll;
                DecodeTime( Time(), wH, wM, wS, wMS );
                sDbName := 'cn' + IntToStr( wH ) + '_' + IntToStr( wM ) + '_' +
                                  IntToStr( wS ) + '_' + IntToStr( wMS );
                try
                  CAR( pDllRec^.fnConnect( true, @pCC, PChar( sDbName ),
                    PChar( GetConnectParams ), PChar( sSharedName ),
                      integer( Self ), @SaCallBack ) );
                except
                  on E : Exception
                  do  begin
                      try
                        pDllRec^.fnConnect( false, @pCC, nil, nil, nil,
                          integer( Self ), @SaCallBack );
                      except
                      end;
                      raise;
                      end;
                end;
                isActive := true;
                Tuning;
                oMonClient.Active := true;
                end;
        end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetSequenced;
begin
  if isVal
  then  SaExecImm( 'SET OPTION ROW_COUNTS = ''ON''' )
  else  SaExecImm( 'SET OPTION ROW_COUNTS = ''OFF''' );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.BeginSequence;
begin
  if ( doSequenced in iOptions ) or ( isSequenced ) then exit;
  SetSequenced( true );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.EndSequence;
begin
  if ( doSequenced in iOptions ) or ( isSequenced ) then exit;
  SetSequenced( false );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.GetConnectParams;
begin
  result := oConnectParams.GetConnectParams( sSaSysDllPath, iVer );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetConnectParams;
begin
  if ( oConnectParams <> nil ) and ( oVal <> nil )
  then  begin
        Active := false;
        DeInitLinkDll;
        oConnectParams.Assign( oVal );
        end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.DoTransact;
begin
  if isActive
  then  begin
        if IsSaTransact
        then  CAR( pDllRec^.fnTransact( pCC, iWhat ) )
        else  if ( iWhat = SA_TRANS_START )
              then  isOnTransact := true
              else  begin
                    isOnTransact := false;
                    CAR( pDllRec^.fnTransact( pCC, iWhat ) );
                    end;
        end
  else  begin
        end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.IsSaTransact;
begin
  result := doSaTransactions in iOptions;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.TransactStart;
begin
  DoTransact( SA_TRANS_START );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.TransactAutoCommit;
begin
  if ( not IsSaTransact ) and ( not IsOnTransact ) then TransactCommit;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.TransactAutoRollBack;
begin
  if ( not IsSaTransact ) and ( not IsOnTransact ) then TransactRollBack;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.TransactCommit;
begin
  DoTransact( SA_TRANS_COMMIT );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.TransactRollBack;
begin
  DoTransact( SA_TRANS_ROLLBACK );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.GetSQLCount;
begin
  result := pDllRec^.fnGetSqlCount( pCC );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function SetDataCallBack(
    pSrc : pointer;
    iGet : integer;
    pDest : pointer;
    iBufSize : integer;
    isBinary : BOOL;
    oSaDb : TSaDbBase
  ) : integer; stdcall;
begin
  with TStream( pSrc )
  do  begin
      result := read( pDest^, iBufSize );
      if not isBinary
      then  Translate( pDest, result, tdToDB, oSaDb.TranslatorNum );
      end;
  oSaDb.Wait( false );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.CreateLongVar;
begin
  if not isActive then exit;
  if ( oStream = nil ) then exit;
  if iSize < 0 then iSize := oStream.Size - oStream.Position;
  CAR( pDllRec^.fnSet( pCC, SA_VAR_CREATE, PChar( sVarName ),
              isBinary, oStream, iSize, @SetDataCallBack, Self ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.DropLongVar;
begin
  if not isActive then exit;
  CAR( pDllRec^.fnSet( pCC, SA_VAR_DROP, PChar( sVarName ),
              false, nil, 0, nil, nil ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.PutVeryLongData;
var
  oDs : TSaDsBase;
  sVarName : string;
  i : integer;
begin
  if not isActive then exit;
  sVarName := sTableName + '_' + sFieldName;
  for i := 1 to Length( sVarName )
  do  if sVarName[ i ] = '.' then sVarName[ i ] := '_';
  CreateLongVar( sVarName, oStream, iSize, isBinary );
  try
    oDs := TSaDsBase.Create;
    try
      oDs.SaDbBase := Self;
      try
        if sWhereCondition <> ''
        then  oDs.ExecStatmImm(
            Format( 'update %s set %s = %s where %s',
                      [ sTableName, sFieldName, sVarName, sWhereCondition ] ) )
        else  oDs.ExecStatmImm(
            Format( 'insert into %s ( %s ) values ( %s )',
                      [ sTableName, sFieldName, sVarName ] ) );
        TransactAutoCommit;
      except
        TransactAutoRollBack;
        raise;
      end;
    finally
      oDs.Free;
    end;
  finally
    DropLongVar( sVarName );
  end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SQLM_Query;
begin
  SQLM_SendQuery( oSaDsBase, false, nil, sStat );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SQLM_PreparedQuery;
begin
  SQLM_SendQuery( oSaDsBase, true, pBind, sStat );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SQLM_SendQuery;
  function  PosChar( sSource : string; c : char; iPos : integer ) : integer;
  begin
    result := Length( sSource );
    while ( iPos <= result ) and ( char( sSource[ iPos ] ) <> c )
    do  Inc( iPos );
    if iPos > result
    then  result := 0
    else  result := iPos;
  end;
var
  oPosList : TList;
  iPos : integer;
  sPrepStat : string;
  i : integer;
  v : variant;
begin
  if not oMonClient.Active then exit;
  if ( oSaDsBase = nil ) or ( pBind = nil ) or ( pBind^.iSqln <= 0 )
  then  sPrepStat := sStat
  else  begin
        oPosList := nil;
        try
          iPos := 1;
          while true
          do  begin
              iPos := PosChar( sStat, '?', iPos );
              if iPos > 0
              then  begin
                    if oPosList = nil
                    then  oPosList := TList.Create;
                    oPosList.Add( pointer( iPos ) );
                    Inc( iPos );
                    end
              else  break;
              end;
          if oPosList <> nil
          then  begin
                sPrepStat := '';
                iPos := 1;
                for i := 0 to oPosList.Count - 1
                do  begin
                    sPrepStat := sPrepStat + Copy( sStat, iPos,
                                             integer( oPosList[ i ] ) - iPos );
                    TSaDsBase( oSaDsBase ).GetSQLDABuf( false, false,
                      i, false, nil, @v, TranslatorNum );
                    if VarIsNull( v )
                    then  sPrepStat := sPrepStat + 'Null'
                    else  sPrepStat := sPrepStat + ''''
                                        + GSVVarToStr( v ) + '''';
                    iPos := integer( oPosList[ i ] ) + 1;
                    end;
                sPrepStat := sPrepStat + Copy( sStat, iPos,
                                             Length( sStat ) + 1 - iPos );
                end
          else  sPrepStat := sStat;
        finally
          oPosList.Free;
        end;
        end;
  if isPrepared
  then  sPrepStat := '+' + sPrepStat
  else  sPrepStat := '-' + sPrepStat;
  oMonClient.Send( PChar( sPrepStat ), Length( sPrepStat ) + 1 );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.InitLinkDll;
var
  iResult : integer;
  sSysPath : string;
  sDllName : string;
begin
  if pDllRec <> nil then exit;
  sSysPath := sSaSysDllPath;
  if ( sSysPath <> '' ) and ( sSysPath[ Length( sSysPath ) ] <> '\' )
  then  sSysPath := sSysPath + '\';
  if sLinkDllName = ''
  then  sDllName := AS_LINKDLL[ iVer ]
  else  sDllName := sLinkDllName;
  iResult := SaLoadLinkDll( sDllName, sSysPath, pDllRec );
  case iResult of
    SA_RES_OK : ;
    SA_RES_INIT_NOTSYSDLL : RSAE( eUser, 0, SA_S_ERR_INIT_NOTSYSDLL );
    SA_RES_INIT_WRONGVERSION : RSAE( eUser, 0, SA_S_ERR_INIT_WRONGVERSION );
  else
    RSAE( eUser, 0, Format( SA_S_ERR_NOTINITLINKDLL, [ sDllName, iResult ] ) );
  end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.DeInitLinkDll;
begin
  if pDllRec = nil then exit;
  SaFreeLinkDll( pDllRec );
  pDllRec := nil;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.SaFetch;
var
  iRes  : integer;
begin
  result := frNotFound;
  InitLinkDll;
  iRes := pDllRec^.fnFetch( pCC, szCursName, pOutSQLDA, isAbs, iAbsRel );
  if iRes = SA_RES_OK
  then  result := frOK
  else  if iRes = SA_RES_CHECKERR
        then  begin
              case pDllRec^.fnGetLastError( pCC, nil, 0 ) of
                SQLE_NOTFOUND : result := frNotFound;
                SQLE_NO_CURRENT_ROW : result := frNoCurrentRow;
                SQLE_ROW_UPDATED_WARNING : result := frUpdateWarning;
              else  CAR( iRes );
              end;
              end
        else  CAR( iRes );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaPrepare;
begin
  InitLinkDll;
  CAR( pDllRec^.fnPrepare( pCC, szSQL, piStat ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaUnPrepare;
begin
  InitLinkDll;
  CAR( pDllRec^.fnUnPrepare( pCC, iStat ), false );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaOpen;
begin
  InitLinkDll;
  CAR( pDllRec^.fnOpen( pCC, szCursName, pInput ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaClose;
begin
  InitLinkDll;
  CAR( pDllRec^.fnClose( pCC, szCursName ), false );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaDeclare;
begin
  InitLinkDll;
  CAR( pDllRec^.fnDeclare( pCC, szCursName, iStat, iCursorOpts ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaChange;
begin
  InitLinkDll;
  CAR( pDllRec^.fnChange( pCC, szCursName, iWhat, pSQLDA, pOutSQLDA ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaFillDa;
begin
  InitLinkDll;
  CAR( pDllRec^.fnFillDA( pCC, pSqlda ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaFreeFilledDa;
begin
  InitLinkDll;
  CAR( pDllRec^.fnFreeFilledDa( pSqlda ), false );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaExec;
begin
  InitLinkDll;
  CAR( pDllRec^.fnExec( pCC, iStat, pInput, pOutput ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaExecImm;
begin
  InitLinkDll;
  CAR( pDllRec^.fnExecImm( pCC, szSQL ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaDescribe;
begin
  InitLinkDll;
  CAR( pDllRec^.fnDescribe( pCC, isDescribeInput, szCursName, iStat, ppSqlda ));
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SaGetData;
begin
  InitLinkDll;
  CAR( pDllRec^.fnGetData( pCC, szCursName, iCol, pDest, pCallBack, iTransl ) );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetSaVersion;
begin
  if iVal = iVer then exit;
  Active := false;
  DeInitLinkDll;
  iVer := iVal;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetSaSysDllPath;
begin
  if sVal = sSaSysDllPath then exit;
  Active := false;
  DeInitLinkDll;
  sSaSysDllPath := sVal;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetSharedName;
begin
  if Trim( sVal ) = sSharedName then exit;
  Active := false;
  sSharedName := Trim( sVal );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.SetLinkDllName;
begin
  if Trim( sVal ) = sLinkDllName then exit;
  Active := false;
  DeInitLinkDll;
  sLinkDllName := Trim( sVal );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.CancelRequest;
begin
  InitLinkDll;
  result := pDllRec^.fnCancelRequest( pCC ) = SA_RES_OK;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.ProcessCallBack;
begin
  case iIndex of
    DB_CALLBACK_WAIT : if Wait( true ) then CancelRequest;
    DB_CALLBACK_MESSAGE : DoDbMessage( pData );
    DB_CALLBACK_DEBUG_MESSAGE :
      if Assigned( mOnDebugMessage )
      then  mOnDebugMessage( StrPas( PChar( pData ) ) );
    DB_CALLBACK_CONN_DROPPED :
      if Assigned( mOnConnDropped ) then  mOnConnDropped;
    DB_CALLBACK_START : if Assigned( mOnStart ) then mOnStart;
    DB_CALLBACK_FINISH : if Assigned( mOnFinish ) then mOnFinish;
  end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.Wait;
begin
  if not Assigned( mOnWait )
  then  result := false
  else  result := mOnWait( isCanCancel );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
procedure TSaDbBase.DoDbMessage;
var
  sMessage : string;
begin
  if Assigned( mOnMessage )
  then  begin
        SetLength( sMessage, pDbMessage^.iLength );
        CopyMemory( @sMessage[ 1 ], pDbMessage^.szMessage,
          pDbMessage^.iLength );
        mOnMessage( TSaMsgType( pDbMessage^.iMsgType ),
                    pDbMessage^.iCode, sMessage );
        end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.GetTranslatorNum;
begin
  result := integer( Translator );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.GetIdentity;
var
  s : array[ 0..32 ] of char;
begin
  InitLinkDll;
  CAR( pDllRec^.fnGetIdentity( pCC, @s[ 0 ], High( s ) - Low( s ) + 1 ) );
  result := PChar( @s[ 0 ] );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.GetDebMsg;
var
  s : array[ 0..254 ] of char;
begin
  pDllRec^.fnGetDebMsg( pCC, @s[ 0 ], Length( s ) );
  result := PChar( @s[ 0 ] );
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}
function TSaDbBase.SaResume;
begin
  result := true;
  InitLinkDll;
  try
    CAR( pDllRec^.fnResume( pCC, szCursName ) );
  except
    on E : Exception
    do  begin
        if ( E is SaException )
          and ( SaException( E ).SQLCode = SQLE_PROCEDURE_COMPLETE )
        then  result := false
        else  raise;
        end;
  end;
end;
{* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *}

{* ************************************************************************** *}

end.


